/**************************************************************************\
*  HighLnk 0.2                            http://www.thpinfo.com/highlnk/  *
*      This source code is released under the terms in the LICENSE file.   *
*  Copyright (c) 2004 Thomas Perl <perl.thomas@aon.at>                     *
\**************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <dirent.h>
#include <linux/limits.h>

#include "md5.h"
#include "finder.h"
#include "highlnk.h"

void findFiles( const char *path, RESULTFUNC results)
{
  DIR *d;               // directory
  struct dirent *e;     // entry
  static struct stat s; // stat
  char *n;              // name

  stat( path, &s);
  (*results)( path, &s);

  if( !(d = opendir( path)))
  {
    fprintf( stderr, "findFiles: Cannot open directory: %s\n", path);
    return;
  }
  
  while( e = readdir( d))
  {
    if( 0 == strcmp( e->d_name, "..") || 0 == strcmp( e->d_name, "."))
      continue;

    n = (char*)malloc( strlen( path) + strlen( e->d_name) + 2);
    strcpy( n, path);
    strcat( n, "/");
    strcat( n, e->d_name);

    stat( n, &s);

    if( S_ISDIR( s.st_mode))
      findFiles( n, results);
    else
      (*results)( n, &s);

    free( n);
  }

  closedir( d);
}

