#ifndef _HIGHLNK_H
#define _HIGHLNK_H

/**************************************************************************\
*  HighLnk 0.2                            http://www.thpinfo.com/highlnk/  *
*      This source code is released under the terms in the LICENSE file.   *
*  Copyright (c) 2004 Thomas Perl <perl.thomas@aon.at>                     *
\**************************************************************************/

#include "md5.h"

/*
   Mask for extracting file permissions from stat.st_mode
*/
#define PERM_MASK 0777

/*
   Usage Message for HighLnk
*/
#define USAGE_MESSAGE "\n\
  Usage: %s target_directory\n\n\
  Hard-links the whole tree from current directory to \n\
  target_directory, making same files the same link, and \n\
  so saving valuable space on both your harddisk and CD-ROM \n\
  media when burning.\n\n\
"

#define print_usage_message() \
  fprintf( stderr, USAGE_MESSAGE, basename( argv[0]));

typedef unsigned char byte;

struct file_target
{
  char* filename;
  struct file_target *next;
};

struct file_source
{
  char *filename;
  uint8 *digest;
  struct file_target *targets;
  struct file_target *targets_end;
  struct file_source *next;
};

struct dir_source
{
  char *dirname;
  struct dir_source *next;
};

#endif

