#ifndef _MD5_H
#define _MD5_H

/**************************************************************************\
*  HighLnk 0.2                            http://www.thpinfo.com/highlnk/  *
*      This source code is released under the terms in the LICENSE file.   *
*  Copyright (c) 2004 Thomas Perl <perl.thomas@aon.at>                     *
\**************************************************************************/

#ifndef uint8
#define uint8  unsigned char
#endif

#ifndef uint32
#define uint32 unsigned long int
#endif

/*
   Input buffer size for calc_md5() function (file-reading buffer)
*/
#define MD5BUFSIZE 4096

typedef struct
{
  uint32 total[2];
  uint32 state[4];
  uint8 buffer[64];
} md5_context;

int calc_md5( const char* filename, uint8 *digest);

void md5_starts( md5_context *ctx );
void md5_update( md5_context *ctx, uint8 *input, uint32 length );
void md5_finish( md5_context *ctx, uint8 *digest);

#endif

